#!/usr/bin/perl

# nanakochi123456 version

BEGIN {
	chdir("/home/ymda/htdocs/denki");
	chdir("/home/ymda/00www/denkiyohou/htdocs");
	require "fatlib.pl";
}

use utf8;
use strict;
use CGI;
use Encode qw/decode decode_utf8/;
use Encode::Guess;
use Nana::Cache;
use HTTP::Lite;
require "common.pl";

my $cache="./cache";
my $tokyodenryoku_base_url="http://www.tepco.co.jp/forecast/html/images/juyo-j.csv";
#my $tokyodenryoku_base_url="http://denkiyohou.local/cache/juyo-j_a18.csv";

my $writefilelist=".write_sokuhou_files";

my $debug;
my $date=&date("Y-m-d");
my $logfile="$cache/usage-$date.log";
my $nextdate=&date("Y-m-d",time+86400);
my $date_ja=&date("Y年m月d日(lL)");
my $nextdate_ja=&date("Y年m月d日(lL)",time+86400);
my $date_ja_mobile=&date("m月d日(lL)");
my $nextdate_ja_mobile=&date("m月d日(lL)",time+86400);

my $sentmitoushi="$cache/$date.sentmitoushi";
my $sentalerm="$cache/$date.sentalerm";
my $sentkantei="$cache/$date.sentkantei";
my $sentkeikakuteiden="$cache/$date.keikakuteiden";

&main;

sub main {
	binmode(STDOUT, ":utf8");
	my $http_body;
	my $status;
	($status,$http_body)=&httpcl($tokyodenryoku_base_url);

	$http_body=~s/\x0D\x0A|\x0D|\x0A/\x0A/g;
	$http_body=&force_decode($http_body);

	if(open(W,">:utf8","$logfile")) {
		print W $http_body;
		close(W);
	}
	my @pwtmp=split(/\n/,$http_body);
	my $update=$pwtmp[0];
	my $kyoukyuu=$pwtmp[2];
	my $maxpower=$pwtmp[5];
	my @pw;

	my $mitoushi_kyoukyuu=$pwtmp[34];
	my $mitoushi_maxpower=$pwtmp[37];

	my($update_date,$update_time,$tmp)=split(/ /,$update);
	my($update_year,$update_mon,$update_day)=split(/\//,$update_date);
	my($update_hour,$update_time)=split(/:/,$update_time);
	my $update_str=sprintf("%d月%d日 %02d時%02d分"
		,$update_mon,$update_day
		,$update_hour,$update_time);
	my $update_rss=sprintf("%04d-%02d-%02dT%02d:%02d:00+0900"
		,&date("Y")
		,$update_mon,$update_day
		,$update_hour,$update_time);
	my($kyoukyuu_kw,$kyoukyuu_time,$kyoukyuu_date,$kyoukyuu_update_time)
		=split(/,/,$kyoukyuu);
	my($maxpower_kw,$maxpower_time,$maxpower_date,$maxpower_update_time)
		=split(/,/,$maxpower);
	my($maxpower_update_mon,$maxpower_update_day)=split(/\//,$maxpower_date);
	my($maxpower_update_hour,$maxpower_update_time)=split(/:/,$maxpower_update_time);
	my $maxpower_update_time_str=sprintf("%02d時%02d分"
		, $maxpower_update_hour,$maxpower_update_time);
	my $maxpower_update_rss=sprintf("%04d-%02d-%02dT%02d:%02d:00+0900"
		,&date("Y")
		,$maxpower_update_mon,$maxpower_update_day
		,$maxpower_update_hour,$maxpower_update_time);

	my $today_persent=int(($maxpower_kw+0) / ($kyoukyuu_kw+0)*100);

	my($mitoushi_kyoukyuu_kw,$mitoushi_kyoukyuu_time,$mitoushi_kyoukyuu_date,$mitoushi_kyoukyuu_update_time)
		=split(/,/,$mitoushi_kyoukyuu);
	my($mitoushi_maxpower_kw,$mitoushi_maxpower_time,$mitoushi_maxpower_date,$mitoushi_maxpower_update_time)
		=split(/,/,$mitoushi_maxpower);
	my($mitoushi_update_hour,$mitoushi_update_time)=split(/:/,$mitoushi_maxpower_update_time);
	my($mitoushi_update_mon,$mitoushi_update_day)=split(/\//,$mitoushi_maxpower_date);
	my $mitoushi_update_time_str=sprintf("%02d時%02d分"
		, $mitoushi_update_hour,$mitoushi_update_time);
	my $mitoushi_rss=sprintf("%04d-%02d-%02dT%02d:%02d:00+0900"
		,&date("Y")
		,$mitoushi_update_mon,$mitoushi_update_day
		,$mitoushi_update_hour,$mitoushi_update_time);
	my $mitoushi_persent;
	$mitoushi_persent=int(($mitoushi_maxpower_kw+0) / ($mitoushi_kyoukyuu_kw+0)*100)
		if($mitoushi_kyoukyuu_kw ne '');

	my $mitoushi_update="$mitoushi_maxpower_date $mitoushi_maxpower_update_time";

	my $mitoushi_msg_tmp=$pwtmp[40];
	my $mitoushi_flg=substr($mitoushi_msg_tmp,0,1);
	my $mitoushi_msg;
	my $mitoushi_msg_m;
	my $mitoushi_msg_tepco;
	my $mitoushi_msg_alert;
	$mitoushi_msg_tepco=substr($mitoushi_msg_tmp,2);
	$mitoushi_msg_alert=substr($mitoushi_msg_tmp,2) if($mitoushi_flg+0 >= 3);
	for(my $i=0; $i<24*(60/5); $i++) {
		$pw[$i]=$pwtmp[$i+44];
	}

	my @hour_refs;
	my($pw_date,$pw_time_tmp,$pw_time,$today_power_tmp,$today_power);
	my $now_persent;
	my $lastflg=0;
	for(my $i=0; $i<24*(60/5); $i++) {
		($pw_date,$pw_time_tmp,$today_power_tmp)
			=split(/,/,$pw[$i]);
		if($today_power_tmp eq '') {
			$lastflg=1;
			last;
		}
		$today_power=$today_power_tmp;
		$pw_time=$pw_time_tmp;
		$now_persent=int(($today_power+0) / ($kyoukyuu_kw+0)*100);
	}
	if($lastflg eq 0) {
		$today_power=$today_power_tmp;
		$pw_time=$pw_time_tmp;
		$now_persent=int(($today_power+0) / ($kyoukyuu_kw+0)*100);
	}
	my($tmp_hour,$tmp_time)=split(/:/,$pw_time);
	my $pw_time_hour=$tmp_hour;
	my $pw_time_time=$tmp_time;
	my $pw_time_ja=sprintf("%d時%02d分",$tmp_hour,$tmp_time);
	my $alertmsg;
	$alertmsg="電気使用をなるだけ控えて下さい。" if($now_persent>=95);
	$alertmsg="電気使用を控えて下さい。" if($now_persent>=97);
	$alertmsg="計画停電の可能性があります。" if($now_persent>=99);
	my $alerthtml;
	$alerthtml="<br /><font color=\"red\"><strong>$alertmsg</strong></font>" if($alertmsg ne '');

	my $today_msg=<<EOM;
@{[$date_ja]}の東京電力の状況 \t(情報更新日時:$maxpower_update_time_str)
ピーク時供給力,@{[$kyoukyuu_kw]}万kW
予想最大電力  ,@{[$maxpower_kw]}万kW
予想最大使用率,@{[$today_persent]}％
ピーク時間帯  ,$maxpower_time
EOM

	my $today_msg_m=<<EOM;
@{[$date_ja]}速報
(@{[$maxpower_update_time_str]}更新)
供給力,@{[$kyoukyuu_kw]}万kW
最大電力  ,@{[$maxpower_kw]}万kW
使用率,@{[$today_persent]}%
時間帯  ,$maxpower_time
EOM
	if($mitoushi_msg_tepco ne '') {
		my $tmp=&jfold($mitoushi_msg_tepco);
		$tmp="\n$tmp" if($tmp ne '');
		$mitoushi_msg=<<EOM;
@{[$nextdate_ja]}の東京電力の見通し \t(情報更新日時:$mitoushi_update_time_str)
ピーク時供給力,@{[$mitoushi_kyoukyuu_kw]}万kW
予想最大電力  ,@{[$mitoushi_maxpower_kw]}万kW
予想最大使用率,@{[$mitoushi_persent]}％
ピーク時間帯  ,$mitoushi_maxpower_time
$tmp
EOM

		$mitoushi_msg_m=<<EOM;
@{[$nextdate_ja]}見通し
(@{[$mitoushi_update_time_str]}更新)
供給力,@{[$mitoushi_kyoukyuu_kw]}万kW
最大電力  ,@{[$mitoushi_maxpower_kw]}万kW
使用率,@{[$mitoushi_persent]}%
時間帯  ,$mitoushi_maxpower_time
EOM
		$mitoushi_msg_alert=&jfold($mitoushi_msg_alert);
	}

	$alertmsg="\n$alertmsg" if($alertmsg);
	my $alertmsg_rss;
	$alertmsg_rss="<br />$alertmsg" if($alertmsg);
	my $usage=<<EOM;
東京電力 $pw_time_ja 使用率 \t(@{[$update_str]}更新) @{[$today_power]}万kW / @{[$kyoukyuu_kw]}万kW (@{[$now_persent]}％)$alerthtml
EOM

	my $usage_m=<<EOM;
東京電力 $pw_time_ja 使用率 \t(@{[$update_str]}更新)
@{[$today_power]}万kW / @{[$kyoukyuu_kw]}万kW (@{[$now_persent]}％)$alerthtml
EOM

	my $twitter="@{[$date]}-$pw_time_hour-$pw_time_time" . ',';
		$twitter.=<<EOM if($pw_time_hour >= 8 && $pw_time_hour <= 21);
@{[$date_ja ]} @{[$pw_time_ja]} @{[$today_power]}万kW / @{[$kyoukyuu_kw]}万kW (@{[$now_persent]}％) #jishin_power
EOM
		if($now_persent >= 99) {
			$twitter.=" 計画停電の可能性があります。#keikakuteiden";
	}
	if(open(R,"$writefilelist")) {
		foreach(<R>) {
			chomp;
			my $file=$_;
			if(open(W,">:utf8","$file")) {
				if($file=~/\.html$/) {
					print W &html($usage);
					print W &html($today_msg);
					if($mitoushi_msg ne '') {
						print W &html($mitoushi_msg);
					}
				} elsif($file=~/\.mhtml$/) {
					print W &html($usage_m,1);
					print W &html($today_msg_m,1);
					if($mitoushi_msg ne '') {
						print W &html($mitoushi_msg_m,1);
						print W &html($mitoushi_msg_alert,1)
							if($mitoushi_msg_alert ne '');
					}
				} elsif($file=~/\.mhtml2$/) {
					print W &html($usage_m,1);
					print W "<hr />\n";
				} elsif($file=~/\.twitter$/) {
					print W $twitter;
				} elsif($file=~/\.xml$/) {
					print W <<EOM;
<?xml version="1.0" encoding="UTF-8"?>
<rdf:RDF
  xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
  xmlns:dc="http://purl.org/dc/elements/1.1/"
  xmlns:sy="http://purl.org/rss/1.0/modules/syndication/"
  xmlns:admin="http://webns.net/mvcb/"
  xmlns:content="http://purl.org/rss/1.0/modules/content/"
  xmlns="http://purl.org/rss/1.0/">

<channel rdf:about="http://denkiyohou.daiba.cx/">
<title>でんき予報速報</title>
<link>http://denkiyohou.daiba.cx/</link>
<description>東京電力のでんき予報速報を配信しています。</description>
<dc:language>ja</dc:language>
<dc:date>$update_rss</dc:date>
</channel>

<item rdf:about="Llink">
<title><![CDATA[でんき予報 @{[$update_str]}使用率]]></title>
<link>http://www.tepco.co.jp/forecast/index-j.html</link>
<description><![CDATA[@{[$today_power]}万kW / @{[$kyoukyuu_kw]}万kW (@{[$now_persent]}％)$alertmsg_rss
]]></description>
<dc:date>$update_rss</dc:date>
</item>

<item rdf:about="Llink">
<title><![CDATA[東京電力@{[$date_ja]}の状況 (@{[$maxpower_update_time_str]}更新)]]></title>
<link>http://www.tepco.co.jp/forecast/index-j.html</link>
<description><![CDATA[
ピーク時供給力：@{[$kyoukyuu_kw]}万kW<br />
予想最大電力  ：@{[$maxpower_kw]}万kW<br />
予想最大使用率：@{[$today_persent]}％<br />
ピーク時間帯  ：$maxpower_time]]></description>
<dc:date>$maxpower_update_rss</dc:date>
</item>
EOM
					if($mitoushi_msg_tepco ne '') {
						print W <<EOM;
<item rdf:about="Llink">
<title><![CDATA[@{[$nextdate_ja]}の東京電力の見通し (@{[$mitoushi_update_time_str]}更新)]]></title>
<link>http://www.tepco.co.jp/forecast/index-j.html</link>
<description><![CDATA[
EOM
						if($mitoushi_msg_alert ne '') {
							print W <<EOM;
$mitoushi_msg_alert<br /><br />
EOM
						}
						print W <<EOM;
ピーク時供給力：@{[$mitoushi_kyoukyuu_kw]}万kW<br />
予想最大電力  ：@{[$mitoushi_maxpower_kw]}万kW<br />
予想最大使用率：@{[$mitoushi_persent]}％<br />
ピーク時間帯  ：$mitoushi_maxpower_time]]></description>
<dc:date>$mitoushi_rss</dc:date>
</item>
EOM
					}
					print W <<EOM;
</rdf:RDF>
EOM
				} else {
					print W &text($usage);
					print W &text("\n");
					print W &text($today_msg);
					if($mitoushi_msg ne '') {
						print W &text("\n");
						print W &text($mitoushi_msg);
					}
				}
				close(W);
			}
		}
		close(R);
	}

		$now_persent=int(($today_power+0) / ($kyoukyuu_kw+0)*100);

	if($now_persent >= 99) {
		if(!-r $sentkeikakuteiden) {
			open(W,">$sentkeikakuteiden");
			close(W);
			open(W,">$sentalerm");
			close(W);
			my $subject="[でんき予報]@{[$now_persent]}% $update_hour:$update_time";
			my $body=<<EOM;
現在使用率が@{[$now_persent]}％となっています。
計画停電の恐れがありますので、ご注意下さい。
また、電気のご使用を控えて頂きますよう
ご協力をお願いします。

供給：@{[$kyoukyuu_kw]}万kW
需要：@{[$today_power]}万kW

計画停電検索サイト
http://power.daiba.cx/
EOM
			&mailallsend($subject,$body);
		}
	}
	if($now_persent >= 97) {
		if(!-r $sentkantei) {
			open(W,">$sentkantei");
			close(W);
			my $subject="[でんき予報]@{[$now_persent]}% $update_hour:$update_time";
			my $body=<<EOM;
現在使用率が@{[$now_persent]}％となっています。
政府からの需給逼迫警報に達しています。
電気のご使用を控えて頂きますようご協力をお願いします。

供給：@{[$kyoukyuu_kw]}万kW
需要：@{[$today_power]}万kW
EOM
			&mailallsend($subject,$body);
		}
	}
	if($now_persent >= 95) {
		if(!-r $sentalerm) {
			open(W,">$sentalerm");
			close(W);
			my $subject="[でんき予報]@{[$now_persent]}% $update_hour:$update_time";
			my $body=<<EOM;
現在使用率が@{[$now_persent]}％となっています。
電気のご使用をできるだけ控えて頂きますよう
ご協力をお願いします。

供給：@{[$kyoukyuu_kw]}万kW
需要：@{[$today_power]}万kW
EOM
			&mailallsend($subject,$body);
		}
	}
	if($mitoushi_flg+0 >= 3) {
		if(!-r $sentmitoushi) {
			open(W,">$sentmitoushi");
			close(W);
			my $subject="[でんき予報]@{[$nextdate_ja_mobile]}の見通し(@{[$mitoushi_persent]}％)";
			my $body=<<EOM;
$mitoushi_msg_alert

ピーク時供給力:@{[$mitoushi_kyoukyuu_kw]}万kW
予想最大電力  :@{[$mitoushi_maxpower_kw]}万kW
予想最大使用率:@{[$mitoushi_persent]}％
ピーク時間帯  :$mitoushi_maxpower_time
EOM
print $body;
			&mailallsend($subject,$body);
		}
	}
}

sub text {
	my($str)=shift;
	$str=~s/[,\t]//g;
	return $str;
}

sub xml {
	my($str)=shift;
	$str=~s/[,\t]//g;
	$str=~s/\n/<br \/>\n/g;
	return $str;
}

sub html {
	my($str,$flg)=@_;
	my $buf;
	my $crlfflg=0;
	$buf.="<table>\n";
	my $colspan=$flg ? 2 : 10;
	foreach(split(/\n/,$str)) {
		if(/\t/ && $flg eq 1) {
			my($tmp1,$tmp2)=split(/\t/,$_);
			$buf.=<<EOM;
<tr><td colspan="$colspan">$tmp1</td></tr>
<tr><td colspan="$colspan">$tmp2</td></tr>
EOM
		} elsif(/,/) {
			my($tmp1,$tmp2)=split(/,/,$_);
			if($flg eq 1) {
				$buf.=<<EOM;
<tr><td>$tmp1:</td><td>$tmp2</td></tr>
EOM
			} else {
				if($crlfflg eq 1) {
					$buf.="<tr>";
				}
				$buf.=<<EOM;
<td>$tmp1：</td><td>$tmp2&nbsp;</td>
EOM
			}
		} else {
			if($crlfflg > 2) {
				$buf.="</tr>\n" if($flg ne 1);
				$crlfflg=0;
			}
			s/\t//g;
			$buf.=<<EOM;
<tr><td colspan="$colspan">$_</td></tr>
EOM
		}
		$crlfflg++;
	}
	$buf.="</tr>\n" if($flg ne 1 && $crlfflg > 3);
	$buf.="</table>\n";
	return($buf);
}

sub jfold {
	my($str)=@_;
	my @strs=split(/。/,$str);
	my $buf;
	foreach(@strs) {
		$buf.="$_。\n";
	}
	$buf=~s/\n$//;
	return $buf;
}

sub httpcl {
	my ($url)=shift;
	my $retry=600;
	my $http=new HTTP::Lite;
	$http->method("GET");
	$http->http11_mode(1);
	$http->add_req_header("User-Agent","denkiyohou (http://denkiyohou.daiba.cx/)");
	my $loop=1;
	my $body;
	my $stat=1;
	for(my $i=0;$i<=$retry;$i++) {
		my $req=$http->request($url);
		if($req eq 200) {
			$body=$http->body();
			$stat=0;
			last;
		}
	}
	$body=~s/\x0D\x0A|\x0D|\x0A/\x0A/g;
	return($stat,$body);
}
